package com.steerinfo.ems.emssafeinfo.service.impl;

import com.steerinfo.ems.Utils.ExcelToolUtils;
import com.steerinfo.ems.emssafeinfo.mapper.EmsSafeinfoMapper;
import com.steerinfo.ems.emssafeinfo.model.EmsSafeinfo;
import com.steerinfo.ems.emssafeinfo.service.IEmsSafeinfoService;
import com.steerinfo.framework.mapper.IBaseMapper;
import com.steerinfo.framework.service.impl.BaseServiceImpl;

import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;


import java.io.InputStream;
import java.util.ArrayList;
import java.util.Date;
import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * EmsSafeinfo服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2023-04-24 10:51
 * 类描述
 * 修订历史：
 * 日期：2023-04-24
 * 作者：generator
 * 参考：
 * 描述：EmsSafeinfo服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "emsSafeinfoService")
@Transactional(rollbackFor=Exception.class)
public class EmsSafeinfoServiceImpl extends BaseServiceImpl<EmsSafeinfo, Short> implements IEmsSafeinfoService {

    @Autowired
    private EmsSafeinfoMapper emsSafeinfoMapper;

    @Override
    protected IBaseMapper<EmsSafeinfo, Short> getMapper() {
        return emsSafeinfoMapper;
    }

    @Override
    public List<EmsSafeinfo> batchImport(String fileName, MultipartFile file) throws Exception {
        String year = fileName.substring(0,4);
        InputStream inputStream = file.getInputStream();
        List<List<String[]>> list = ExcelToolUtils.parseExcels(inputStream, fileName, 0);
        List<EmsSafeinfo>emsSafeinfoList = new ArrayList<>();

        for (int i = 0; i < list.size(); i++) {
            String[] arr2 = list.get(i).get(1);
            for (int j = 1; j < list.get(i).size(); j++) {
                EmsSafeinfo emsSafeinfo= new EmsSafeinfo();
                String[] arr = list.get(i).get(j);
                String[] arr1 = list.get(i).get(0);
                for (int k = 1; k < arr1.length; k++) {

                    if (arr1[k].trim().indexOf("序号")!=-1){

                    }
                    else if (arr1[k].trim().indexOf("日期")!=-1){
                         emsSafeinfo.setDates(arr[k].trim());
                     }else  if (arr1[k].trim().indexOf("工序")!=-1) {
                            emsSafeinfo.setProcess(arr[k].trim());

                        }else  if(arr1[k].trim().indexOf("地点")!=-1) {
                        emsSafeinfo.setProcess(arr[k].trim());

                    }
                    else if(arr1[k].trim().indexOf("内容")!=-1){
                         emsSafeinfo.setContent(arr[k].trim());

                     }else if(arr1[k].trim().indexOf("备注")!=-1){
                         emsSafeinfo.setMemo(arr[k].trim());

                     }
                }
                emsSafeinfoList.add(emsSafeinfo);
            }
        }
        if (emsSafeinfoList.size()>0){

            return emsSafeinfoList;
        }else {
            return null;
        }
    }

    @Override
    public List<EmsSafeinfo> getList(Map<String, Object> parameters) {
        List<EmsSafeinfo> list = this.getMapper().selectByParameters(parameters);
        return list;
    }
}
